local drawQueue = {
	callStack = {}
}

function drawQueue:fillTo(to)
	for i = 1, to, 1 do
		self.callStack[i] = {}
	end
end
drawQueue:fillTo(16)

function drawQueue:add( priority, call )
	if not self.callStack[priority] then
		self:fill()
	end
	table.insert( self.callStack[priority], call )
end

function drawQueue:flush()
	for priority, calls in ipairs( self.callStack ) do
		for k, call in ipairs( calls ) do
			call()
		end
	end
	self.callStack = {}
	drawQueue:fillTo(16)
end

return drawQueue