local enemy = love.filesystem.load('enemies/baseenemy.lua')()

enemy.speed = 75
enemy:setImage( love.graphics.newImage( 'images/ships/enemy5.png') )
enemy:setCollisionBody( HC:addRectangle( -100, 0, enemy.width, enemy.height ) )
enemy:setMaxHealth( 40 )
enemy:setMovement(
	function( self, dt )

		self.y = self.y + levelMoveSpeed * dt
		self.goal_y = self.goal_y + levelMoveSpeed * dt
		self.start_y = self.start_y + levelMoveSpeed * dt
		
		if math.abs( self.goal_x - self.x ) <= 1 then
			self.x = self.goal_x
		elseif self.x > self.goal_x then
			self.x = self.x - self.speed * dt
		elseif self.x < self.goal_x then
			self.x = self.x + self.speed * dt
		end
	
		if math.abs( self.goal_y - self.y ) <= 1 then
			self.y = self.goal_y
		elseif self.y > self.goal_y then
			self.y = self.y - self.speed * dt
		elseif self.y < self.goal_y then
			self.y = self.y + self.speed * dt
		end
	
		if self.goal_y == self.y and self.goal_x == self.x then
			self:resetGoal()
		end

	end 
)

function enemy:resetGoal()
	self.goal_y = self.start_y + math.random( -2, 2 ) * 40
	self.goal_x = self.start_x + math.random( -2, 2 ) * 40
end

function enemy:setLocation( x, y )
	self.x = x
	self.y = y
	self.start_x = x
	self.start_y = y
	self:resetGoal()	 
end

function enemy:shoot()
end

return enemy