local enemy = love.filesystem.load('enemies/baseenemy.lua')()

enemy.firing = false
enemy.roundsFired = 0
enemy.roundCharge = 0
enemy.roundFireSpeed = 0.1
enemy.fireSpeed = 2
enemy.roundsPerVolley = 4

enemy:setImage( love.graphics.newImage( 'images/ships/enemy2.png') )
enemy:setCollisionBody( HC:addRectangle( -100, 0, enemy.width, enemy.height ) )
enemy:setMaxHealth( 100 )
enemy:setMovement( 
	function( self, dt )
		self.y = self.y + self.speed * dt
		self.x = self.x + 5 * dt 
	end 
)


function enemy:chargeShot( dt )
	self.charge = self.charge + dt
	if self.firing then		
		self.roundCharge = self.roundCharge + dt
		if self.roundCharge > self.roundFireSpeed then			
			self.roundCharge = self.roundCharge - self.roundFireSpeed
			self.roundsFired = self.roundsFired + 1
			self:shoot()
		end
		if self.roundsFired == self.roundsPerVolley then
			self.roundsFired = 0
			self.firing = false
			self.roundCharge = 0
		end		
	elseif self.charge > self.fireSpeed then
		self.charge = self.charge - self.fireSpeed
		self.firing = true		
	end
end

function enemy:shoot()
	self.projectiles:new( self.x, self.y, 0.75 * math.pi )
	self.projectiles:new( self.x, self.y, 1.25 * math.pi )
end

enemy.projectiles = love.filesystem.load('projectiles/diagonalenemyprojectile.lua')()

return enemy