local explosion = {}
	
function explosion:newExplosion( x, y )
	local newExplosion = {
		x = x,
		y = y,
		size = 0,
		maxSize = 10,
		color = { 255, 0, 0, 150 },
		blastSpeed = 60,
		
		update = function( self, dt )
			self.size = self.size + self.blastSpeed * dt
		end,	
		
		draw = function( self )
			drawQueue:add( 8, 
				function()
					love.graphics.setColor( self.color )
					love.graphics.circle( 'fill', self.x, self.y, self.size )
					love.graphics.setColor( resetColor )
				end
			)
		end,
		
		dead = function( self ) 
			return self.size > self.maxSize
		end,
		
		cleanup = function( self )
		
		end
	}
	
	return newExplosion
end

function explosion:newLargeExplosion( x, y )
	local newExplosion = {
		x = x,
		y = y,
		size = 0,
		maxSize = 25,
		color = { 255, 0, 0, 150 },
		blastSpeed = 90,
		
		update = function( self, dt )
			self.size = self.size + self.blastSpeed * dt
		end,	
		
		draw = function( self )
			drawQueue:add( 8, 
				function()
					love.graphics.setColor( self.color )
					love.graphics.circle( 'fill', self.x, self.y, self.size )
					love.graphics.setColor( resetColor )
				end
			)
		end,
		
		dead = function( self ) 
			return self.size > self.maxSize
		end,
		
		cleanup = function( self )
		
		end
	}
	
	return newExplosion
end

return explosion