
local levelstring = love.filesystem.load( 'levels/level1.txt' )()

local on = 1
local x = 0
local enemies = {}
local level = { currentSpot = 0, next = {}, contents = {} }

-- determine level length
for i = 1, #levelstring do
    local c = levelstring:sub(i,i)
    if c == "\n" then    	    	
		on = on + 2
	end
end

function createEnemy( x, enemyName )
	return function()
		local enemy = love.filesystem.load('enemies/' .. enemyName .. '.lua')()			
		enemy:setLocation( x, -50 )
		return enemy
	end
end

-- insert enemies
for i = 1, #levelstring do
    local c = levelstring:sub(i,i)
    if c == "\n" then    	    	
    	x = 0
    	table.insert( level.contents, { on = on, contents = enemies } )
    	enemies = {}
    	on = on - 2
    else 
    	x = x + 30
    end
    
    if c == "1" then
    	table.insert( enemies, createEnemy( x, 'enemy' ) )
    end
    if c == "2" then
    	table.insert( enemies, createEnemy( x, 'scattershot' ) )
    end
    if c == "3" then
    	table.insert( enemies, createEnemy( x, 'swerver' ) )
    end

    if c == "4" then
    	table.insert( enemies, createEnemy( x, 'bumper' ) )
    end
    
    if c == "5" then
    	table.insert( enemies, createEnemy( x, 'aerialmine' ) )
    end
    	
end

level.next = table.remove( level.contents )

function level:update(dt)
	if self.next then		
		self.currentSpot = self.currentSpot + dt
		if self.currentSpot > self.next.on then
			self:handleNext()
		end
	else
		
	end
end

function level:handleNext()
	for k, item in ipairs( self.next.contents ) do
		table.insert( entities, item() )
	end	
	self.next = table.remove( level.contents )
end

function level:draw()
end

function level:dead()
	return false
end

function level:cleanup()
end

return level