local powerup = {

	pickedUp = false,
	body = nil,
	image = love.graphics.newImage( 'images/effects/powerup.png'),
	x = 0,
	y = 0,
	ct = 'powerup',
	start_x = 0,
	start_y = 0,
	goal_x = 0,
	goal_y = 0,
}


powerup.body = HC:addRectangle( 0, 0, powerup.image:getWidth(), powerup.image:getHeight() )
powerup.body.parent = powerup

function powerup:setLocation( x, y )
	self.x = x
	self.y = y
	self.start_x = x
	self.start_y = y
	self:resetGoal()
end

function powerup:dead()
	return self.pickedUp or self.y > viewportHeight + 50
end

function powerup:cleanup()
	HC:remove( self.body )
	self.body = nil
end

function powerup:update( dt )
	self.y = self.y + levelMoveSpeed * dt
	self.goal_y = self.goal_y + levelMoveSpeed * dt
	self.start_y = self.start_y + levelMoveSpeed * dt
	
	if math.abs( self.goal_x - self.x ) <= 1 then
		self.x = self.goal_x
	elseif self.x > self.goal_x then
		self.x = self.x - 10 * dt
	elseif self.x < self.goal_x then
		self.x = self.x + 10 * dt
	end

	if math.abs( self.goal_y - self.y ) <= 1 then
		self.y = self.goal_y
	elseif self.y > self.goal_y then
		self.y = self.y - 10 * dt
	elseif self.y < self.goal_y then
		self.y = self.y + 10 * dt
	end

	if self.goal_y == self.y and self.goal_x == self.x then
		self:resetGoal()
	end
	
	self.body:moveTo( self.x, self.y )
end

function powerup:draw()
	drawQueue:add( 5,
		function()
			love.graphics.draw( self.image, self.x, self.y )		
		end
	)
	
end

function powerup:resetGoal()
	self.goal_y = self.start_y + math.random( -1, 1 ) * 25
	self.goal_x = self.start_x + math.random( -1, 1 ) * 25
end

function powerup:pickup( player )
	self.pickedUp = true	
end

return powerup