local enemyProjectile = {}

function enemyProjectile:new( x, y, direction  )
	local newProjectile = {
		x = x,
		y = y,
		direction = direction or math.pi, -- down
		ct = 'enemyProjectile',		
		damage = 5,
		isDead = false,
		speed = 400,
		image = love.graphics.newImage( 'images/effects/enemyprojectile.png'),
		
		draw = function( self ) 
			drawQueue:add( 8,
				function()
					love.graphics.draw( self.image, self.x - self.image:getWidth()/2, self.y - self.image:getHeight()/2 )
				end
			)
		end,
		
		update = function( self, dt )
			self.y = self.y - self.speed * math.cos( self.direction ) * dt
			self.x = self.x - self.speed * math.sin( self.direction ) * dt
		
	
			self.body:moveTo( self.x, self.y )
		end,
		
		dead = function( self )
			return 	self.isDead or
					self.x < 0 or self.x > viewportWidth or
					self.y < 0 or self.y > viewportHeight 
					
		end,
		
		cleanup = function( self )					
			HC:remove( self.body )
			self.body = nil
		end,
		
		resolve = function( self, player )
			player:takeDamage( self.damage )
			self.isDead = true
		end
	}
	newProjectile.body = HC:addRectangle( x, y, newProjectile.image:getWidth(), newProjectile.image:getHeight() )
	newProjectile.body.parent = newProjectile
	
	table.insert( entities, newProjectile )
end

return enemyProjectile