local projectile = {}

function projectile:new( x, y, direction )
	local newProjectile = {
		x = x,
		y = y,
		ct = 'playerProjectile',
		direction = direction,
		damage = 5,
		isDead = false,
		speed = 600,
		image = love.graphics.newImage( 'images/effects/playerprojectile.png'),
		draw = function( self )
			drawQueue:add( 8,
				function()
					love.graphics.draw( self.image, self.x + self.image:getWidth(), self.y + self.image:getHeight() )
				end
			)
		end,
		
		update = function( self, dt )
			self.y = self.y - self.speed * dt
			self.body:moveTo( self.x, self.y )
		end,
		
		dead = function( self )
			return 	self.isDead or
					self.x < 0 or self.x > viewportWidth or
					self.y < 0 or self.y > viewportHeight 
					
		end,
		
		cleanup = function( self )					
			HC:remove( self.body )
			self.body = nil
		end,
		
		resolve = function( self, enemy )
			enemy:takeDamage( self.damage )
			self.isDead = true
		end
	}
	newProjectile.body = HC:addRectangle( x, y, newProjectile.image:getWidth(), newProjectile.image:getHeight() )
	newProjectile.body.parent = newProjectile
	
	table.insert( entities, newProjectile )
end

return projectile
