local weapon = {
	firespeed = 5,
	reload = 0,
	projectile = love.filesystem.load('projectiles/rocket.lua')( weapon ),
	mustDraw = false,
	maxDrawTime = 0.025,
	drawnFor = 0,
	ammo = 100,
	shooting = false,
	numFired = 0,
	maxFired = 196,
	firetime = 2,
}

function weapon:fire( dt )
	if self.ammo > 0 and self.reload <= 0 then
		self.shooting = true
		self.reload = self.firespeed
		self.ammo = self.ammo - 1
	end
end

function weapon:update( dt )
	self.reload = self.reload - dt
	if self.shooting then
		local numToShoot = math.floor( dt / self.firetime * self.maxFired + 0.5 )
		numToShoot = math.min( numToShoot, self.maxFired - self.numFired )
		
		for i = 1, numToShoot do
			self.projectile:new( self.ship.x + math.random( -10, 10 ), self.ship.y + math.random( -10, 10 ), math.random( -100, 100 ) / 1000 * math.pi  )
		end
		
		self.numFired = self.numFired + numToShoot
		if self.numFired >= self.maxFired then
			self.numFired = 0
			self.shooting = false
		end
	end
end

function weapon:draw()
	
end

return weapon