local weapon = {
	firespeed = 0.05,
	reload = 0,
	projectile = love.filesystem.load('projectiles/projectile.lua')( weapon ),
	mustDraw = false,
	maxDrawTime = 0.025,
	drawnFor = 0
}

function weapon:fire( dt )
	if self.reload <= 0 then
		self.projectile:new( self.ship.x-self.ship.width/4-5, self.ship.y-self.ship.height/2+20, 0 )
		self.projectile:new( self.ship.x+self.ship.width/4+5, self.ship.y-self.ship.height/2+20, 0 )
		self.reload = self.firespeed
		self.drawnFor = 0
		self.mustDraw = true 
	end
end

function weapon:update( dt )
	self.reload = self.reload - dt	
	if self.mustDraw then
		self.drawnFor = self.drawnFor + dt
	end
	if self.drawnFor >= self.maxDrawTime then
		self.mustDraw = false
	end
end

function weapon:draw()
	if self.mustDraw then
		drawQueue:add( 9,
			function()
				love.graphics.setColor( 255, 0, 0, 120)
				love.graphics.circle( "fill", self.ship.x-self.ship.width/4-5, self.ship.y-self.ship.height/2+20, 4 )
				love.graphics.circle( "fill", self.ship.x+self.ship.width/4+5, self.ship.y-self.ship.height/2+20, 4 )
				love.graphics.setColor( resetColor )
			end
		)
	end
end

return weapon